import { methods, RawLinkedList } from 'awesome-collections-core';
export { LinkedListNode, RawLinkedList } from 'awesome-collections-core';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _defineProperty from '@babel/runtime/helpers/defineProperty';

var _Symbol$iterator;
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
_Symbol$iterator = Symbol.iterator;
var LinkedList = /*#__PURE__*/function () {
  function LinkedList(iterator) {
    _classCallCheck(this, LinkedList);
    _defineProperty(this, "nodes", new RawLinkedList());
    if (iterator) {
      var _iterator = _createForOfIteratorHelper(iterator),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var _value = _step.value;
          this.push(_value);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }
  }
  _createClass(LinkedList, [{
    key: "size",
    get: function get() {
      return this.nodes.length;
    }
  }, {
    key: "head",
    get: function get() {
      var _this$nodes$head;
      return (_this$nodes$head = this.nodes.head) === null || _this$nodes$head === void 0 ? void 0 : _this$nodes$head.value;
    }
  }, {
    key: "tail",
    get: function get() {
      var _this$nodes$tail;
      return (_this$nodes$tail = this.nodes.tail) === null || _this$nodes$tail === void 0 ? void 0 : _this$nodes$tail.value;
    }
  }, {
    key: _Symbol$iterator,
    value: function value() {
      return methods.values(this.nodes);
    }
  }, {
    key: "values",
    value: function values() {
      return methods.values(this.nodes);
    }
  }, {
    key: "keys",
    value: function keys() {
      return methods.keys(this.nodes);
    }
  }, {
    key: "entries",
    value: function entries() {
      return methods.entries(this.nodes);
    }
  }, {
    key: "push",
    value: function push() {
      for (var _len = arguments.length, items = new Array(_len), _key = 0; _key < _len; _key++) {
        items[_key] = arguments[_key];
      }
      return methods.push.apply(methods, [this.nodes].concat(items));
    }
  }, {
    key: "unshift",
    value: function unshift() {
      for (var _len2 = arguments.length, items = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        items[_key2] = arguments[_key2];
      }
      return methods.unshift.apply(methods, [this.nodes].concat(items));
    }
  }, {
    key: "pop",
    value: function pop() {
      return methods.pop(this.nodes);
    }
  }, {
    key: "shift",
    value: function shift() {
      return methods.shift(this.nodes);
    }
  }, {
    key: "get",
    value: function get(index) {
      return methods.get(this.nodes, index);
    }
  }, {
    key: "set",
    value: function set(index, value) {
      return methods.set(this.nodes, index, value);
    }
  }, {
    key: "delete",
    value: function _delete(index) {
      return methods.deleteValue(this.nodes, index);
    }
  }, {
    key: "insert",
    value: function insert(index, value) {
      return methods.insert(this.nodes, index, value);
    }
  }, {
    key: "forEach",
    value: function forEach(callbackfn, thisArg) {
      methods.forEach.bind(this)(this.nodes, callbackfn, thisArg);
    }
  }, {
    key: "clear",
    value: function clear() {
      return methods.clear(this.nodes);
    }
  }, {
    key: "slice",
    value: function slice() {
      var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var end = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.nodes.length;
      var newLinkedList = new LinkedList();
      newLinkedList.nodes = methods.slice(this.nodes, start, end);
      return newLinkedList;
    }
  }, {
    key: "copy",
    value: function copy() {
      return this.slice();
    }
  }, {
    key: "at",
    value: function at(index) {
      return methods.at(this.nodes, index);
    }
  }, {
    key: "indexOf",
    value: function indexOf(searchElement) {
      var fromIndex = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      return methods.indexOf(this.nodes, searchElement, fromIndex);
    }
  }, {
    key: "lastIndexOf",
    value: function lastIndexOf(searchElement) {
      var fromIndex = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.size - 1;
      return methods.lastIndexOf(this.nodes, searchElement, fromIndex);
    }
  }, {
    key: "includes",
    value: function includes(searchElement) {
      var fromIndex = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      return methods.includes(this.nodes, searchElement, fromIndex);
    }
  }, {
    key: "find",
    value: function find(predicate, thisArg) {
      var find = methods.findValue.bind(this);
      return find(this.nodes, predicate, thisArg)[1];
    }
  }, {
    key: "findIndex",
    value: function findIndex(predicate, thisArg) {
      var find = methods.findValue.bind(this);
      return find(this.nodes, predicate, thisArg)[0];
    }
  }, {
    key: "some",
    value: function some(cb, thisArg) {
      return this.findIndex(cb, thisArg) > -1;
    }
  }, {
    key: "every",
    value: function every(predicate, thisArg) {
      var every = methods.every.bind(this);
      return every(this.nodes, predicate, thisArg);
    }
  }, {
    key: "map",
    value: function map(callbackfn, thisArg) {
      var newLinkedList = new LinkedList();
      var addValue = function addValue(currentValue) {
        return newLinkedList.push(currentValue);
      };
      var map = methods.map.bind(this);
      map(this.nodes, addValue, callbackfn, thisArg);
      return newLinkedList;
    }
  }, {
    key: "filter",
    value: function filter(predicate, thisArg) {
      var result = new LinkedList();
      var addValue = function addValue(currentValue) {
        return result.push(currentValue);
      };
      var filter = methods.filter.bind(this);
      filter(this.nodes, addValue, predicate, thisArg);
      return result;
    }
  }, {
    key: "sort",
    value: function sort(compareFn) {
      methods.sort(this.nodes, compareFn);
      return this;
    }
  }, {
    key: "reduce",
    value: function reduce(callbackfn, initialValue) {
      var reduce = methods.reduce.bind(this);
      return arguments.length === 1 ? reduce(this.nodes, callbackfn) : reduce(this.nodes, callbackfn, initialValue);
    }
  }, {
    key: "reduceRight",
    value: function reduceRight(callbackfn, initialValue) {
      var reduceRight = methods.reduceRight.bind(this);
      return arguments.length === 1 ? reduceRight(this.nodes, callbackfn) : reduceRight(this.nodes, callbackfn, initialValue);
    }
  }, {
    key: "join",
    value: function join() {
      var separator = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : ',';
      return methods.join(this.nodes, separator);
    }
  }, {
    key: "toString",
    value: function toString() {
      return methods.toString(this.nodes);
    }
  }, {
    key: "reverse",
    value: function reverse() {
      methods.reverse.call(this, this.nodes);
      return this;
    }
  }, {
    key: "concat",
    value: function concat() {
      var newLinkedList = new LinkedList();
      for (var _len3 = arguments.length, items = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        items[_key3] = arguments[_key3];
      }
      newLinkedList.nodes = methods.concat.apply(methods, [this.nodes].concat(items));
      return newLinkedList;
    }
  }, {
    key: "splice",
    value: function splice(start) {
      var deleteCount = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.size;
      var newLinkedList = new LinkedList();
      for (var _len4 = arguments.length, items = new Array(_len4 > 2 ? _len4 - 2 : 0), _key4 = 2; _key4 < _len4; _key4++) {
        items[_key4 - 2] = arguments[_key4];
      }
      newLinkedList.nodes = methods.splice.apply(methods, [this.nodes, start, deleteCount].concat(items));
      return newLinkedList;
    }
  }, {
    key: "flat",
    value: function flat() {
      var depth = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      var newLinkedList = new LinkedList();
      newLinkedList.nodes = methods.flat(this.nodes, depth);
      return newLinkedList;
    }
  }, {
    key: "flatMap",
    value: function flatMap(callback, thisArg) {
      var newLinkedList = new LinkedList();
      newLinkedList.nodes = methods.flatMap(this.nodes, callback, thisArg, this);
      return newLinkedList;
    }
  }, {
    key: "fill",
    value: function fill(value) {
      var start = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var end = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : this.size;
      this.nodes = methods.fill(this.nodes, value, start, end);
      return this;
    }
  }], [{
    key: "isLinkedList",
    value:
    /**
     * Check if the argument is an linked list
     * @returns true if the argument is a linked list, otherwise false
     */
    function isLinkedList(linkedList) {
      return linkedList instanceof LinkedList;
    }
  }]);
  return LinkedList;
}();

export { LinkedList };
